<script>
    import LegendColorBar from "./LegendColorBar.svelte";
    import { fade } from "svelte/transition";

    export let subplot;
    export let xScale;

    const valid_plot_types_for_legend = [
        "line",
        "wiggle",
        "area",
        "color_mapped_symbols",
        "interval_image",
        "epoch_image",
    ];

    const plot_types_for_color_bar_legend = [
        "color_mapped_symbols",
        "interval_image",
        "epoch_image",
    ];

    $: plot_types = subplot.plot_elements.map(
        (pe) => pe.plot_options.plot_type,
    );

    $: color_bar_included_multiplier = plot_types.some((item) =>
        plot_types_for_color_bar_legend.includes(item),
    )
        ? 1
        : 0;

    let default_bar_width = 190;
    let bar_width = default_bar_width;
    let swatch_width = 15;
    let swatch_height = 10;
    let offset_left = 25;
    let offset_bottom = 15;
    let text_offset_left = 10;
    let row_height = 18;
    let text_size = 12;
    let margin = 8;
    let align_horizontal = "right";
    let align_vertical = "top";

    const compute_legend_dimensions = function (plot_elements) {
        let num_rows = 0;
        let row_indices = [];
        for (var i = 0; i < plot_elements.length; i++) {
            let el = plot_elements[i];

            if (
                !("include_in_legend" in el) &&
                el.visible &&
                valid_plot_types_for_legend.includes(el.plot_options.plot_type)
            ) {
                row_indices[i] = num_rows;
                if (
                    el.plot_options.plot_type == "line" ||
                    el.plot_options.plot_type == "wiggle" ||
                    el.plot_options.plot_type == "area" ||
                    el.plot_options.plot_type == "bars"
                ) {
                    num_rows = num_rows + 1;
                } else if (
                    el.plot_options.plot_type == "color_mapped_symbols" ||
                    el.plot_options.plot_type == "interval_image" ||
                    el.plot_options.plot_type == "epoch_image"
                ) {
                    num_rows = num_rows + 3;
                }
            }
        }
        return { num_rows: num_rows, row_indices: row_indices };
    };
    $: legend_geometry = compute_legend_dimensions(subplot.plot_elements);
    $: visible_plot_elements = subplot.plot_elements.filter((pe) => {
        return pe.visible == true;
    });

    $: leftMargin = xScale.range()[0];
    $: rightMargin = xScale.range()[1];

    const set_legend_position = function (
        subplot,
        xScale,
        align_horizontal,
        align_vertical,
        legend_box_width,
        legend_box_height,
    ) {
        let x_left;
        let y_bottom;
        if (align_horizontal == "left") {
            x_left = xScale.range()[0] + offset_left;
        } else {
            x_left = xScale.range()[1] - legend_box_width;
        }
        if (align_vertical == "top") {
            y_bottom = subplot.computed.y + legend_box_height;
        } else {
            y_bottom = subplot.computed.y + subplot.computed.h - offset_bottom;
        }
        return [x_left, y_bottom];
    };

    $: legend_box_width =
        2 * margin +
        Math.max(bar_width * color_bar_included_multiplier, max_text_width) +
        2 * text_offset_left +
        swatch_width;

    $: legend_box_height =
        offset_bottom + row_height * legend_geometry.num_rows + 2 * margin;

    $: [x_left, y_bottom] = set_legend_position(
        subplot,
        xScale,
        align_horizontal,
        align_vertical,
        legend_box_width,
        legend_box_height,
    );

    let text_elems = [];
    const compute_max_text_width = function (text_elems, plot_elements) {
        let text_widths = text_elems
            .filter((e, i) => {
                return (
                    plot_elements[i].visible &&
                    !("include_in_legend" in plot_elements[i])
                );
            })
            .map((e) => e?.getBBox().width);
        let max_text_width = Math.max(...text_widths);
        let max_width = max_text_width > 1 ? max_text_width : 10;
        return max_width;
    };

    $: max_text_width = compute_max_text_width(
        text_elems,
        subplot.plot_elements,
    );
    let show_close_button = false;

    const text_decoration = function (plot_element) {
        if (plot_element.visible == false) {
            return "none"; // "line-through"
        } else {
            return "none";
        }
    };
</script>

<g
    class="legend"
    on:focus={() => {
        show_close_button = true;
    }}
    on:mouseover={() => {
        show_close_button = true;
    }}
    on:mouseleave={() => {
        show_close_button = false;
    }}
    transition:fade|local={{ duration: 200 }}>
    <!-- Background rounded rectangle -->
    <rect
        filter="url(#dropShadow)"
        x={x_left - margin}
        y={y_bottom - 2 * margin - row_height * legend_geometry.num_rows}
        width={legend_box_width}
        height={row_height * legend_geometry.num_rows + 1.5 * margin}
        rx="6"
        ry="6"
        fill="white"
        fill-opacity="1"
        stroke="black"
        stroke-width="1"
        stroke-opacity="0"
        class="fill-white dark:fill-gray-700" />

    <!-- Invisible circle just for the mouseover/mouseout triggering of the group -->
    <circle
        cx={x_left - margin}
        cy={y_bottom - margin - row_height * (legend_geometry.num_rows + 0.5)}
        r="20"
        fill="white"
        fill-opacity="0"
        stroke="none"
        stroke-width="0px" />

    {#if show_close_button}
        <g
            class="legend_close_button"
            on:click={() => {
                subplot.legend_visible = false;
            }}
            on:keypress={(event) => {
                if (event.key === "Enter") {
                    subplot.legend_visible = false;
                }
            }}
            transition:fade|local={{ duration: 100 }}
            style="cursor: pointer">
            <circle
                cx={x_left - margin}
                cy={y_bottom -
                    margin -
                    row_height * (legend_geometry.num_rows + 0.5)}
                r="8"
                fill="white"
                fill-opacity="1"
                stroke="black"
                stroke-width="1px" />

            <path
                transform="translate({x_left - margin},{y_bottom -
                    margin -
                    row_height * (legend_geometry.num_rows + 0.5)})"
                style="stroke: black; stroke-width: 1px;"
                d="M-3 3 L3 -3 M3 3 L-3 -3" />
        </g>
    {/if}

    {#each subplot.plot_elements as plot_element, i_plot_element}
        {#if !("include_in_legend" in plot_element) && plot_element.visible && valid_plot_types_for_legend.includes(plot_element.plot_options.plot_type)}
            {#if plot_element.plot_options.plot_type == "area"}
                <!-- Swatch for area plot -->
                <rect
                    x={x_left}
                    y={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height -
                        text_size * 0.5}
                    rx={swatch_height * 0.3}
                    ry={swatch_height * 0.3}
                    width={swatch_width}
                    height={swatch_height}
                    fill={plot_element.plot_options.fill}
                    fill-opacity={plot_element.plot_options["fill-opacity"]}
                    stroke={plot_element.plot_options.stroke}
                    stroke-width={plot_element.plot_options["stroke-width"]}
                    stroke-opacity={plot_element.plot_options[
                        "stroke-opacity"
                    ]} />
            {:else if plot_element.plot_options.plot_type == "line"}
                <!-- Swatch for line plot -->
                <line
                    x1={x_left}
                    x2={x_left + swatch_width}
                    y1={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height}
                    y2={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height}
                    stroke={plot_element.plot_options.stroke}
                    stroke-width={plot_element.plot_options["stroke-width"]}
                    stroke-opacity={plot_element.plot_options[
                        "stroke-opacity"
                    ]} />
            {:else if plot_element.plot_options.plot_type == "wiggle"}
                <!-- Swatch for wiggle plot -->
                <rect
                    x={x_left}
                    y={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height -
                        text_size * 0.5}
                    width={swatch_width}
                    height={swatch_height}
                    fill={plot_element.plot_options.fill}
                    fill-opacity={plot_element.plot_options["fill-opacity"]}
                    stroke="none"
                    stroke-width="0"
                    stroke-opacity="0" />
                <line
                    x1={x_left + swatch_width}
                    x2={x_left + swatch_width}
                    y1={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height -
                        text_size * 0.5}
                    y2={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height -
                        text_size * 0.5 +
                        swatch_height}
                    stroke={plot_element.plot_options.stroke}
                    stroke-width={plot_element.plot_options["stroke-width"]}
                    stroke-opacity={plot_element.plot_options[
                        "stroke-opacity"
                    ]} />
                {console.log(plot_element.plot_options.wiggle_scale)}
            {:else if plot_element.plot_options.plot_type == "color_mapped_symbols"}
                <LegendColorBar
                    {plot_element}
                    x_coordinate={x_left + swatch_width + text_offset_left}
                    barWidth={bar_width}
                    y_coordinate_bar={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height} />
            {:else if plot_element.plot_options.plot_type == "interval_image"}
                <LegendColorBar
                    {plot_element}
                    x_coordinate={x_left + swatch_width + text_offset_left}
                    barWidth={bar_width}
                    y_coordinate_bar={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height} />
            {:else if plot_element.plot_options.plot_type == "epoch_image"}
                <LegendColorBar
                    {plot_element}
                    x_coordinate={x_left + swatch_width + text_offset_left}
                    barWidth={bar_width}
                    y_coordinate_bar={y_bottom -
                        row_height * (legend_geometry.num_rows + 1) +
                        (legend_geometry.row_indices[i_plot_element] + 1) *
                            row_height} />
            {/if}

            <!-- Text label -->
            <text
                bind:this={text_elems[i_plot_element]}
                x={x_left + swatch_width + text_offset_left}
                y={y_bottom -
                    row_height * (legend_geometry.num_rows + 1) +
                    (legend_geometry.row_indices[i_plot_element] + 1) *
                        row_height +
                    text_size / 3}
                dominant-baseline="auto"
                text-anchor="begin"
                font-family="-apple-system, 'Helvetica Neue', sans-serif"
                font-size={text_size}
                font-weight="normal"
                text-decoration={text_decoration(
                    subplot.plot_elements[i_plot_element],
                )}
                class="fill-black dark:fill-white">
                {plot_element.title}
            </text>
        {/if}
    {/each}
</g>
